//$Id: DEUpgradePackPostProcessor.java,v default 19087:db1f7b087579 2012/02/01 11:17:49 rajasiddharthan.n $
package com.adventnet.ncm.upgradepack;

import com.adventnet.ncm.client.components.devicechooser.DeviceChooserUtil;
import com.adventnet.ncm.client.credential.NCMCredentialUtil;
import java.util.*;
import java.util.logging.*;
import java.io.*;
import javax.transaction.*;
import org.jboss.tm.*;
import java.sql.Connection;
import com.adventnet.db.api.*;
import com.adventnet.tools.update.*;
import com.adventnet.persistence.*;
import com.adventnet.ds.query.*;
import com.adventnet.ncm.*;
import com.adventnet.topology.*;
import com.adventnet.clientframework.*;
import com.adventnet.authentication.*;
import com.adventnet.clientcomponents.ACCOLUMNCONFIGURATION;
import com.adventnet.clientcomponents.*;
import com.adventnet.ncm.util.*;
import com.adventnet.ncm.*;
import com.adventnet.persistence.*;
import java.io.File;
import com.adventnet.ds.query.util.*;
import com.adventnet.ncm.config.ExecutionConstants;
import java.sql.Timestamp;
public class DEUpgradePackPostProcessor extends DefaultPostProcessor
{
  Logger logger = Logger.getLogger(DEUpgradePackPostProcessor.class.getName());
  String removeFiles[]={"ant.jar","commons-modeler.jar","servlets-common.jar","ant-launcher.jar","commons-pool-1.2.jar","servlets-default.jar","catalina-cluster.jar","jakarta-regexp-1.3.jar","servlets-invoker.jar","catalina-i18n-es.jar","jasper-compiler.jar","servlets-webdav.jar","catalina-i18n-fr.jar","jasper-runtime.jar","catalina-i18n-ja.jar","jkconfig.jar","catalina-optional.jar","jkshm.jar","tomcat-http11.jar","commons-collections-3.1.jar","naming-common.jar","tomcat-jk2.jar","commons-dbcp-1.2.1.jar","naming-factory.jar","tomcat-jk.jar","commons-el.jar","naming-java.jar","tomcat-jni.jar","commons-fileupload-1.0.jar","naming-resources.jar","tomcat-util.jar"}; //NO I18N
  String removeNCMFiles[]={"jcifs-krb5-1.2.13.jar"};//No I18N
    public void installPatch(Properties props) throws Exception 
    {
	TransactionManager tm = DataAccess.getTransactionManager();
        //defaultTransactionTimeout does not take effect
	//((org.jboss.tm.TxManager)tm).setDefaultTransactionTimeout(30000);
        ((org.jboss.tm.TxManager)tm).setTransactionTimeout(35000);
	super.installPatch(props);
   
    }


    public void updateDOXmls() throws Exception
    {
        
        if(migrateDB())
        {
        super.updateDOXmls();

        System.out.println("Proceeding with migration ...");
    
	//handleTomcatJars();
        //handleNCMJars();
        // 1. Removing the Personalization & UserView Personalization info
        removePersonalizationInfo();

	System.out.println(" before addAdmin ");
	System.out.println(" After  before addAdmin ");
        // 2. Adding new operations for existing resources for selected device templates
        populatePPMHandlingTable();
//        populateCMRuleDGTable();
	// 3. Handling nmap changes
	//handleNmap();

        //4. Populating NCMBackupStateHolder Table
        //populateBSHTable();

	//updateJoinTable();
        deleteSQLMigrationFiles();
	addAdminTab();                
        System.out.println("Successfully completed migration ...");
    }
        else
        {System.out.println("DB Migration skipped as the node updated is secondary.");}

    }

    private boolean migrateDB()
    {
        boolean returnvalue =false;
        try
        {
            System.out.println("Checking if the server is a primary or a secondary");
            SelectQuery versionSQ = new SelectQueryImpl(new Table(ACCOLUMNCONFIGURATION.TABLE));
            versionSQ.addSelectColumn(new Column(ACCOLUMNCONFIGURATION.TABLE, "*"));
            Criteria ruleCriteria = new Criteria(new Column(ACCOLUMNCONFIGURATION.TABLE, ACCOLUMNCONFIGURATION.COLUMNALIAS), "productversion", QueryConstants.EQUAL);
            versionSQ.setCriteria(ruleCriteria);
            DataObject versionDO = DataAccess.get(versionSQ);
            Row versionRow = versionDO.getFirstRow(ACCOLUMNCONFIGURATION.TABLE);
            String versionStr = (String) versionRow.get(ACCOLUMNCONFIGURATION.STATIC_TEXT);
            
            String serverHome = new File(System.getProperty("server.home", "..")).getCanonicalPath();
            File infFile = new File(serverHome+File.separator+"Patch"+File.separator+"inf.xml");
            FileReader fr = new FileReader(infFile);
            BufferedReader br = new BufferedReader(fr);
            String temp = br.readLine().trim();
            String infVersion = null;
            while(temp!=null)
            {
                
                if(temp.startsWith("<productVersion>"))
                {
                    infVersion = temp.substring(temp.indexOf(">")+1,temp.lastIndexOf("<"));
                    break;
                }
                else
                {temp=br.readLine().trim();}
            }
            
            if (versionStr.equals(infVersion)) 
            {
                returnvalue = true;
            }
        }
        catch(Exception e)
        {
            System.out.println("The exception is "+e);
        }
        return returnvalue ;
    }
    
    private void populateBSHTable()
    {
        try
        {

            System.out.println("Starting to populate data to BackupStateHolder Table");
            SelectQuery resSQ = new SelectQueryImpl(new Table(NCMOPERATIONSTATEHOLDER.TABLE));
            resSQ.addSelectColumn(new Column(NCMOPERATIONSTATEHOLDER.TABLE, NCMOPERATIONSTATEHOLDER.RESOURCEID));
            resSQ.addSelectColumn(new Column(NCMOPERATIONSTATEHOLDER.TABLE, NCMOPERATIONSTATEHOLDER.OPERATIONTYPE));
            resSQ.addSelectColumn(new Column(NCMOPERATIONSTATEHOLDER.TABLE, NCMOPERATIONSTATEHOLDER.OPERATIONSTATUS));
            resSQ.addSelectColumn(new Column(NCMOPERATIONSTATEHOLDER.TABLE, NCMOPERATIONSTATEHOLDER.LASTBACKUPOPERATIONTIME));
            DataObject bshDO =  new WritableDataObject();
            DataObject resDO = DataAccess.get(resSQ);
            Iterator itr = resDO.getRows(NCMOPERATIONSTATEHOLDER.TABLE);
            Row resRow = null;
            Row bshRow=null;
            String oprStatus ,oprType;
            Long resID,oprTime;
            Timestamp bkpTime;
            while(itr.hasNext())
            {
                resRow = (Row)itr.next();
                resID=(Long)resRow.get(NCMOPERATIONSTATEHOLDER.RESOURCEID);
                bshRow=new Row(NCMBACKUPSTATEHOLDER.TABLE);
                bshRow.set(NCMBACKUPSTATEHOLDER.RESOURCEID,resID);
                oprType=resRow.get(NCMOPERATIONSTATEHOLDER.OPERATIONTYPE).toString();
                if(oprType.equals("Backup"))
                {
                     oprStatus = resRow.get(NCMOPERATIONSTATEHOLDER.OPERATIONSTATUS).toString();
                     if(oprStatus.equals(ExecutionConstants.FAILURE)||oprStatus.equals(ExecutionConstants.SUCCESS))
                     {
                         oprTime=(Long)resRow.get(NCMOPERATIONSTATEHOLDER.LASTBACKUPOPERATIONTIME);
                         bkpTime=new Timestamp(oprTime);
                         bshRow.set(NCMBACKUPSTATEHOLDER.BACKUP_STATUS,oprStatus);
                         bshRow.set(NCMBACKUPSTATEHOLDER.TIMESTAMP,bkpTime);
                     }
                }
                else{
                    bshRow.set(NCMBACKUPSTATEHOLDER.BACKUP_STATUS,ExecutionConstants.NOTSTARTED);
                    }
                bshDO.addRow(bshRow);
            }
            DataAccess.add(bshDO);
            System.out.println("Successfully populated NCMBackupStateHolder");
        }
        catch(Exception ex)
        {
            System.out.println("PPM INSTALLATION : Exception occurred during populating BackupStateHolder Table.\n"+ex.getMessage());
            ex.printStackTrace();
        }
    
    }
    
    private void populateCMRuleDGTable()
    {
        try
        {

            logger.log(Level.INFO,"starting to populate values in ncmcmruledgmap's associated_by_id column");//No I18N
            DataObject ruleDO, userDO ;
            Row cmdgRow;
            String modifiedBy;
            Long ruleID,assignedBy;
            Criteria ruleCriteria, userCriteria;
           
            SelectQuery sq = new SelectQueryImpl(new Table(NCMCMRULEDGMAP.TABLE));
            sq.addSelectColumn(new Column(NCMCMRULEDGMAP.TABLE, "*"));
            DataObject cmruleDGDO = DataAccess.get(sq);
            Iterator itr = cmruleDGDO.getRows(NCMCMRULEDGMAP.TABLE);
            
            while(itr.hasNext())
            {
                cmdgRow = (Row)itr.next();
                ruleID=(Long)cmdgRow.get(NCMCMRULEDGMAP.RULE_ID);
                ruleCriteria = new Criteria(new Column(NCMCHANGEMGMTRULE.TABLE,NCMCHANGEMGMTRULE.RULE_ID),ruleID,QueryConstants.EQUAL);
                ruleDO = DataAccess.get(NCMCHANGEMGMTRULE.TABLE,ruleCriteria);
                modifiedBy = (String)ruleDO.getFirstValue(NCMCHANGEMGMTRULE.TABLE, NCMCHANGEMGMTRULE.LAST_MODIFIED_BY);
                userCriteria = new Criteria(new Column(AAALOGIN.TABLE,AAALOGIN.NAME),modifiedBy,QueryConstants.EQUAL);
                userDO = DataAccess.get(AAALOGIN.TABLE, userCriteria);
                
                if(userDO.containsTable(AAALOGIN.TABLE))
                {
                    assignedBy = (Long)userDO.getFirstValue(AAALOGIN.TABLE,AAALOGIN.LOGIN_ID);
                }
                else
                {
                    userCriteria = new Criteria(new Column(AAALOGIN.TABLE,AAALOGIN.NAME),"admin",QueryConstants.EQUAL);
                    userDO = DataAccess.get(AAALOGIN.TABLE, userCriteria);
                    assignedBy = (Long)userDO.getFirstValue(AAALOGIN.TABLE,AAALOGIN.LOGIN_ID);
                }
                    cmdgRow.set(NCMCMRULEDGMAP.ASSOCIATED_BY_ID, assignedBy);
                    cmruleDGDO.updateRow(cmdgRow);
                }
                DataAccess.update(cmruleDGDO);
                
            logger.log(Level.INFO, "Successfully populated NCMCMRuleDgMap table");//No I18N
        }
        catch(Exception ex)
        {
            logger.log(Level.INFO,"PPM INSTALLATION : Exception occurred during populating NCMCMRuleDgMap table.\n"+ex.getMessage());//No I18N
            ex.printStackTrace();
        }
    
    }
    
    private void removePersonalizationInfo()
    {
        try
        {
            // Removing the _PERSVIEW_% views from ViewConfiguration
            System.out.println("Going to remove the personalized views ...");
            Criteria criteria = new Criteria(new Column(VIEWCONFIGURATION.TABLE,VIEWCONFIGURATION.VIEWNAME),
                    "*_PERSVIEW_*",QueryConstants.CONTAINS);
            DataAccess.delete(criteria);
            System.out.println("Successfully removed the Personalized views.");

            // Removing the UserView Personalization info
            System.out.println("Going to remove the NCMUserViewDC Personalization info.");
            DataAccess.delete(NCMUSERVIEWDC.TABLE,(Criteria)null);
            System.out.println("Successfully removed the NCMUserViewDC Personalization info.");
        }
        catch(Exception ex)
        {
            System.out.println("PPM INSTALLATION : Exception occurred during UserPersonalizationInfo cleanup.\n"+ex.getMessage());
            ex.printStackTrace();
        }
    }

    
    private void populatePPMHandlingTable()
    {
        try
        {
            // Adding new operations for existing resources
            System.out.println("Going to populate ncmppmhandling table");

            // Main query to get details for all relevant devices in inventory
            SelectQuery queryImpl = new SelectQueryImpl(new Table(RESOURCES.TABLE));
            queryImpl.addSelectColumn(new Column(RESOURCES.TABLE,RESOURCES.RESOURCEID));

            Join join = new Join(RESOURCES.TABLE,NCMRESOURCESINFO.TABLE,new String[] {RESOURCES.RESOURCEID},
                                            new String[] {NCMRESOURCESINFO.RESOURCEID},Join.INNER_JOIN);
            queryImpl.addJoin(join);

            join = new Join(NCMRESOURCESINFO.TABLE,NCMDEVICETEMPLATE.TABLE,new String[] {NCMRESOURCESINFO.DEVICETEMPLATEID},
                    new String[] {NCMDEVICETEMPLATE.DEVICETEMPLATEID},Join.INNER_JOIN);
            queryImpl.addJoin(join);

            join = new Join(NCMDEVICETEMPLATE.TABLE,NCMDEVICEPERSONALITY.TABLE,
                                            new String[] {NCMDEVICETEMPLATE.DEVICETEMPLATEID},
                                            new String[] {NCMDEVICEPERSONALITY.DEVICETEMPLATEID},Join.INNER_JOIN);
            queryImpl.addJoin(join);


            join = new Join(RESOURCES.TABLE,NCMCREDENTIALVALIDITY.TABLE,
                                            new String[] {RESOURCES.RESOURCEID},
                                            new String[] {NCMCREDENTIALVALIDITY.RESOURCEID},Join.INNER_JOIN);
            queryImpl.addJoin(join);


            Criteria cri1 = new Criteria(new Column(NCMDEVICETEMPLATE.TABLE,NCMDEVICETEMPLATE.TEMPLATENAME),
                    new String[]{""},QueryConstants.IN); //NO I18N


            Criteria cri2 = new Criteria(new Column(NCMCREDENTIALVALIDITY.TABLE,NCMCREDENTIALVALIDITY.VALIDITY),"true",QueryConstants.EQUAL);
            queryImpl.setCriteria(cri1.and(cri2));

            DataObject resourcesDO = DataAccess.get(queryImpl);

            System.out.println(" Resources DO fetched to update PPMHandling table is : " + resourcesDO);

            DataObject ppmHandlingDO = new WritableDataObject();
            Iterator itr = resourcesDO.getRows(RESOURCES.TABLE);
            Row resRow = null;
            Row ppmHandlingRow = null;
            DataObject ppmDO=getPreviousPatchEntry();
            while(itr.hasNext())
            {
                resRow = (Row)itr.next();
                Long resID=(Long)resRow.get(RESOURCES.RESOURCEID);

                if(!checkIfRowExists(ppmDO,resID))
                {
                ppmHandlingRow = new Row(NCMPPMHANDLING.TABLE);
                ppmHandlingRow.set(NCMPPMHANDLING.RESOURCEID,resRow.get(RESOURCES.RESOURCEID));
                ppmHandlingDO.addRow(ppmHandlingRow);
                }
            }

            DataAccess.add(ppmHandlingDO);
            System.out.println("Successfully populated ncmppmhandling table : " + ppmHandlingDO);
        }
        catch(Exception ex)
        {
            System.out.println("PPM INSTALLATION : Exception occurred during populating PPMHandling Table.\n"+ex.getMessage());
            ex.printStackTrace();
        }
    }    
    
   private boolean checkIfRowExists(DataObject ppmDO,Long resID)
   {
       Row resRow=null;
       try
       {
	   Iterator itr = ppmDO.getRows(NCMPPMHANDLING.TABLE);
	   while(itr.hasNext())
	   {
                resRow = (Row)itr.next();
                Long resourceID=(Long)resRow.get(NCMPPMHANDLING.RESOURCEID);
                if(resourceID.equals(resID))
                {
                    return true;
                }
            }
        }
        catch(Exception e)
        {
            System.out.println(" Issue while getting rows from DataObject " + ppmDO);
        }
        return false;
   }
   private void handleNCMJars(){
		   for (int i = 0; i < removeNCMFiles.length; i++) {
			   File n = new File("./lib/"+removeNCMFiles[i]);//No I18N
			   logger.log(Level.INFO, "Deleted "+n.getName());//No I18N
			   boolean res=n.delete();
				   if(!res)
				   {
					   n.deleteOnExit();
				   }
			   }
		   }

   private void handleTomcatJars(){
		   for (int i = 0; i < removeFiles.length; i++) {
			   File n = new File("./lib/tomcat/"+removeFiles[i]);
			   System.out.println(n.getName());
			   boolean res=n.delete();
				   if(!res)
				   {
					   n.deleteOnExit();
				   }

			   }

		   }

//Fix for CiscoSwitch not updated in CiscoSwitchGroup 

   private void updateJoinTable()
   {

	   try{
	   UpdateQueryImpl query = new UpdateQueryImpl(JOINTABLE.TABLE); //NO I18N
	   Column column = new Column(JOINTABLE.TABLE,JOINTABLE.TABLEALIAS); //NO I18N
	   Criteria crit = new Criteria(column,"NCMResourceCustomColumn",QueryConstants.EQUAL); //NO I18N
	   query.setCriteria(crit);
	   query.setUpdateColumn(JOINTABLE.JOINTYPE,1); //NO I18N 
	   DataAccess.update(query);
	   }catch(Exception exp)
	   {
           System.out.println(" Issue while updating JoinTable "+exp.getMessage()); //NO I18N
	   }

   }

  private void addAdminTab()
  {

	try{
	SelectQuery queryImpl = new SelectQueryImpl(new Table(NCMREBRANDING.TABLE));
       queryImpl.addSelectColumn(new Column(NCMREBRANDING.TABLE,"*"));
      //Criteria ruleCriteria = new Criteria(new Column(NCMREBRANDING.TABLE, NCMREBRANDING.HIDESUPPORTPAGE), 1, QueryConstants.EQUAL);
        //    queryImpl.setCriteria(ruleCriteria);

           DataObject resourceDO = DataAccess.get(queryImpl);
	
	   System.out.println(" resourseDO "+resourceDO);	 
 
	   if(!resourceDO.isEmpty())
	   {

		System.out.println(" into is Empti ");
		SelectQuery mainImpl = new SelectQueryImpl(new Table(VIEWCONFIGURATION.TABLE));
		mainImpl.addSelectColumn(new Column(VIEWCONFIGURATION.TABLE,"*"));
		Criteria mainCriteria = new Criteria(new Column(VIEWCONFIGURATION.TABLE,VIEWCONFIGURATION.VIEWNAME),"NCMMainTab",QueryConstants.EQUAL);
		mainImpl.setCriteria(mainCriteria);
		DataObject mainDO = DataAccess.get(mainImpl);
		
		Long viewNameNumber=(Long) mainDO.getFirstValue("ViewConfiguration","VIEWNAME_NO");

		System.out.println(" viewNameNumber "+viewNameNumber);

		SelectQuery adminmainImpl = new SelectQueryImpl(new Table(VIEWCONFIGURATION.TABLE));
                adminmainImpl.addSelectColumn(new Column(VIEWCONFIGURATION.TABLE,"*"));
                Criteria adminCriteria = new Criteria(new Column(VIEWCONFIGURATION.TABLE,VIEWCONFIGURATION.VIEWNAME),"NCMAdminView",QueryConstants.EQUAL);
                adminmainImpl.setCriteria(adminCriteria);
                DataObject adminmainDO = DataAccess.get(mainImpl);

		Long adminNameNumber=(Long) adminmainDO.getFirstValue("ViewConfiguration","VIEWNAME_NO");
		
		System.out.println(" adminNameNumber "+adminNameNumber);

		DataObject supDO= new WritableDataObject();
                        Row supRow = new Row("ACTabChildConfig");
                        supRow.set("VIEWNAME",viewNameNumber);
                        supRow.set("CHILDVIEWNAME",adminNameNumber);
                        supRow.set("CHILDINDEX",5); //NO I18N
                        supDO.addRow(supRow);
                        DataAccess.add(supDO);
		}
	
	}catch(Exception e)
	{
		e.printStackTrace();
		}


	}




   private DataObject getPreviousPatchEntry()
   {
       DataObject resourceDO=null ;
       SelectQuery queryImpl = new SelectQueryImpl(new Table(NCMPPMHANDLING.TABLE));
       queryImpl.addSelectColumn(new Column(NCMPPMHANDLING.TABLE,NCMPPMHANDLING.RESOURCEID));
       try
       {
           resourceDO = DataAccess.get(queryImpl);
       }
       catch(Exception e)
       {
           System.out.println(" Issue while fetching data from NCMPPMHandling "+e.getMessage());
       }
       return resourceDO;
   }


   private static void handleNmap()
   {
          try{

	  if(System.getProperty("os.name").toLowerCase().contains("window"))
	  {
		  Runtime runcmd = Runtime.getRuntime();
		  deleteDir(new File("nmap"));
		  renameDir("nmap_windows","nmap");
		  deleteDir(new File("nmap_linux"));
	  }else
	  {
		  Runtime runcmd = Runtime.getRuntime();
		  runcmd.exec("mv nmap nmap_");
		  runcmd.exec("mv nmap_linux nmap");
		  deleteDir(new File("nmap_windows"));
	  }

	  }catch(Exception e)
	  {
		  System.out.println(" Issue in moving nmap changes "+e.getMessage());
	  }
   }


   public static void deleteSQLMigrationFiles()
   {
     try{
       File dbSh = new File("./bin/mysql_mssql_backup.sh");
       File dbBat = new File("./bin/mysql_mssql_backup.bat");
       File resSh = new File("./bin/mysql_mssql_restore.sh");
       File resBat = new File("./bin/mysql_mssql_restore.bat");
       
       if(System.getProperty("os.name").toLowerCase().contains("window"))
       {
            
           boolean res=dbSh.delete();
           if(!res)
	   {
		   dbSh.deleteOnExit();
	   }
           res=resSh.delete();
           if(!res)
	   {
		   resSh.deleteOnExit();
	   }
       }
       else
       {
           boolean res=dbBat.delete();
           if(!res)
	   {
               dbBat.deleteOnExit();
	   }
           res=resBat.delete();
           if(!res)
	   {
	       resBat.deleteOnExit();
	   }
       }
      }
     catch(Exception e)
	  {
		  System.out.println(" Issue in deleting mssql_mysql migration script and bat "+e.getMessage());
	  }
   }
   
   public static boolean deleteDir(File dir) {
	   if (dir.isDirectory()) {
		   String[] children = dir.list();
		   for (int i=0; i<children.length; i++) {
			   boolean success = deleteDir(new File(dir, children[i]));
			   if (!success) {
				   return false;
			   }
		   }
	   }

	   return dir.delete();
   }

   public static void renameDir(String originalFileName, String renameFileName)
   {
	   File originalFile = new File(originalFileName);
	   File renameFile = new File(renameFileName);
	   originalFile.renameTo(renameFile);

   }


}




